<?php
require_once 'secureLogin.php';
require_once 'form_elements.php';

// check if the uploaded file is a valid language file
function is_language_file($file)
{
	$kw = '$lang';
	$kwcount = 0;
	$validlevel = 49;

	$handle = fopen($file, 'r');
	if($handle) {
		while (!feof($handle)) {
			$buffer = fgets($handle);
			// count the number of keywords in the file
			$pos = strpos($buffer, $kw);
			if($pos === false) {}
			else
				$kwcount++;
		}
	} else
		echo 'Cannot open file';

	fclose($handle);

	if( $kwcount > $validlevel )
		return true;
	else
		return false;
}

function regini($filename, $fileattrs)
{
	// initialize
	$lang_file = array();
	global $langdir, $usersettingdir;

	// create the COM object
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('add_lang_file.php FSCONFIG.Cfgmgr Object cannot be created!');
	// get default language file name
	$lang_file[] = $settingobj->getkey('default_lang_file', 'lang');
	// get the number of other language file
	$lfnum = $settingobj->getkey('lang_fileNumber', 'lang');
	// get file names of other language file
	if($lfnum>0)
		for( $i=1; $i<=$lfnum; $i++ )
			$lang_file[] = $settingobj->getkey("lang_file$i", 'lang');

	$repeat = false;
	// check input filename with records in .ini data
	foreach( $lang_file as $key => $value ) {
		if( $value == $filename ) {
			$repeat = true;
			$num = $key;
		}
	}
	if(!$repeat)
		$num = ++$lfnum;

	// register the new lang file in config.ini
	$rsult = $settingobj->setkey($filename, "lang_file$num", 'lang');
	$rsult = $settingobj->setkey($fileattrs, "lang_file{$num}_attributes", 'lang');
	$rsult = $settingobj->setkey($lfnum, 'lang_fileNumber', 'lang');

	// release the COM object
	////$settingobj->Release();
	$settingobj=null;
}

function defaultlangfilename()
{
	$settingobj = new COM('FSCONFIG.Cfgmgr') or die('add_lang_file.php FSCONFIG.Cfgmgr Object cannot be created!');
	// get default language file name
	$name = $settingobj->getkey('default_lang_file', 'lang');
	// release the COM object
	////$settingobj->Release();
	$settingobj=null;

	return $name;
}

// begin
/*
    $state = 1  : Initial state
    $state = 2  : Upload Successfully
    $state = 3  : Not a language file
    $state = 4  : Language file duplicated
    $state = 5  : Ask user replace the file or not
    $state = 6  : Other unexpected state
    $state = 7  : Default language file
*/
$langdir = "..\\authserv\\lang\\";
$usersettingdir = "..\\usersetting\\";
$state = 1;
$errmsg='';

// check whether the file is uploaded
if( isset( $_POST['state1'] ) ) {
    if( is_uploaded_file($_FILES['userlangfile']['tmp_name']) ) { // file uploaded
		if( ($_FILES['userlangfile']['type'] == 'text/plain' || $_FILES['userlangfile']['type'] == 'application/octet-stream') && is_language_file($_FILES['userlangfile']['tmp_name']) ) {
			if( file_exists($usersettingdir.$_FILES['userlangfile']['name']) ) {
				if( $_FILES['userlangfile']['name'] == defaultlangfilename() ) {
					$errmsg = get_cm_var('setcfg_ui_add_overwrite_default');
					$state = 7;
				} else {
					// use session to store the origin data
					// NOTES: The only reason of using session here is because we need to ask user if replace the file that already exists
					$_SESSION['uploadfilename'] = $_FILES['userlangfile']['name'];
					$_SESSION['fileattrs'] = $_POST['lang_desc'].';'.$_POST['lang_region'].';'.$_POST['lang_charset'];
					$tmppath = pathinfo($_FILES['userlangfile']['tmp_name']);
					$_SESSION['tempname'] = $tmppath['basename'];

					// move the file to language dir and save as temp
					if( move_uploaded_file($_FILES['userlangfile']['tmp_name'], $usersettingdir.$_SESSION['tempname']) ) {
						$errmsg = $_SESSION['uploadfilename'].get_cm_var('setcfg_ui_add_already_exist');
						$state = 4;
					} else {
						$errmsg = get_cm_var('setcfg_ui_add_attack');
						$state = 6;
					}
				}
			} else {
				if( move_uploaded_file($_FILES['userlangfile']['tmp_name'], $usersettingdir.$_FILES['userlangfile']['name']) ) {
					regini($_FILES['userlangfile']['name'], $_POST['lang_desc'].';'.$_POST['lang_region'].';'.$_POST['lang_charset']);
					$state = 2;
					$errmsg = get_cm_var('setcfg_ui_add_lang_file').' '.$_FILES['userlangfile']['name'].get_cm_var('setcfg_ui_add_added');
				} else {
					$errmsg = get_cm_var('setcfg_ui_add_attack');
					$state = 6;
				}
			}
		} else {
			$errmsg = $_FILES['userlangfile']['name'].get_cm_var('setcfg_ui_add_not_valid');
			$state = 3;
		}
	} else {
		$errmsg = get_cm_var('setcfg_ui_add_fail');
		$state = 6;
	}
} elseif( isset($_POST['replace']) ) {
	if( $_POST['replace'] == 'true' ) {
		unlink($usersettingdir.$_SESSION['uploadfilename']);
		rename($usersettingdir.$_SESSION['tempname'], $usersettingdir.$_SESSION['uploadfilename']);
		regini($_SESSION['uploadfilename'], $_SESSION['fileattrs']);
		$state = 2;
		$errmsg = get_cm_var('setcfg_ui_add_lang_file').' '.$_SESSION['uploadfilename'].get_cm_var('setcfg_ui_add_added');
	} else {
		unlink($usersettingdir.$_SESSION['tempname']);
		$state = 6;
		$errmsg = get_cm_var('setcfg_ui_add_canceled');
	}
	unset($_SESSION['uploadfilename']);
	unset($_SESSION['tempname']);
	unset($_SESSION['fileattrs']);
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Add a Language File</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<style type="text/css">
<!--
  body { background: #FFFFFF; font-family: 'Tahoma',sans-serif; }
  h2 { font-family:sans-serif; font-weight: bold; color: green; }
  hr { border: 1px solid #BAEAD6; }
  input.longtextbox { width:250px; border:1px solid #99D1A2; font-family: sans-serif,'Tahoma'; font-size:10pt; }
  input.shorttextbox { width:80px; border:1px solid #99D1A2; font-family:sans-serif,'Tahoma'; font-weight: bold; font-size:10pt; }
  div.save { margin-top: 18px; }
  div.box { border: 2px solid #99D1A2; font-size: 12pt; font-family: sans-serif; color:#003300; text-align:center; background:#E3E3E3; padding:6px; }
  .captionbig { font-size:10pt; font-weight:bold; color:#003300; }
  ul { list-style:none; margin:5px 0px 0px 5px; padding:0px; }
  ul li { padding:3px 0px 3px 0px; }
  label.left { float:left; width:160px; }
  span.error { font-size:10pt; font-weight:bold; color:red; }
-->
</style>
</head>

<body>
<h2><?=get_cm_var('setcfg_ui_add_heading')?></h2>
<?  if( $state == 1 ): ?>
<script type="text/javascript" src="./javascript/ui_custom.js"></script>
<div class="box"><strong><?=get_cm_var('setcfg_ui_add_title_upload')?></strong></div>
<form name="uploadform" action="add_lang_file.php" enctype="multipart/form-data" method="POST" onSubmit="return validateStep1();">
<input type="hidden" name="MAX_FILE_SIZE" value="30000000">
<input type="hidden" name="state1" value="true">

<span class="error"><?=$errmsg?></span>
<ul class="captionbig">
    <li><label for="lang1" class="left"><?=get_cm_var('setcfg_ui_add_lang_file')?></label><input name="userlangfile" id="lang1" type="file" value="" class="longtextbox">
    <hr noshade>
    <li><label for="lang2" class="left"><?=get_cm_var('setcfg_ui_desc')?></label><input type="text" name="lang_desc" id="lang2" value="" maxlength="30" class="longtextbox">
    <hr noshade>
    <li><label for="lang3" class="left"><?=get_cm_var('setcfg_ui_languages')?></label><input type="text" name="lang_region" id="lang3" value="" class="longtextbox">
    <li><label class="left">&nbsp;</label><?=gen_language_box('add_language')?><input type="button" value="Add" id="button_add_lang" title="Add languages" disabled onclick="add_lang();">
    <hr noshade>
    <li><label for="lang4" class="left"><?=get_cm_var('setcfg_ui_char_encode')?></label><input type="text" name="lang_charset" id="lang4" value="" class="longtextbox">
    <li><label class="left">&nbsp;</label><?=gen_charset_box('add_charset')?><input type="button" value="Add" id="button_add_charset" title="Add character encoding" disabled onclick="add_character_encoding();">
</ul>
<div align="center" class="save">
<input type="submit" value="<?=get_cm_var('setcfg_ui_add_save')?>" style="font-weight:bold; margin-right:15px;">
<input type="button" value="<?=get_cm_var('setcfg_ui_add_close')?>" onclick="window.close()">
</div>
</form>
<script type="text/javascript">
<!--
function validateStep1()
{
    if( document.uploadform.userlangfile.value == '' ) {
        alert( 'Please specify a file to upload!' );
        return false;
    } else if( document.uploadform.lang_desc.value == '' ) {
        alert( 'Please input description!' );
        return false;
    } else if( document.uploadform.lang_region.value == '' ) {
        alert( 'Please input a language!' );
        return false;
    } else if( document.uploadform.lang_charset.value == '' ) {
        alert( 'Please input a charater encoding!' );
        return false;
    }
    return true;
}
    // apply onchange properity on selection box "add_language"
    var oSelectBox = document.getElementById('add_language');
    if( oSelectBox )
        oSelectBox.onchange = new Function('enable_add_button("add_language", "button_add_lang")');

    // apply onchange properity on selection box "add_charset"
    var oSelectBox = document.getElementById('add_charset');
    if( oSelectBox )
        oSelectBox.onchange = new Function('enable_add_button("add_charset", "button_add_charset")');
// -->
</script>

<?  elseif( $state == 2 ): ?>
<div class="box"><h4>Complete!!!</h4></div>
<span class="captionbig" style="color:green;"><?=$errmsg?></span>
<div align="center" class="save">
<input type="button" value="OK" onclick="window.opener.location.reload( false );window.close();">
</div>

<?  elseif( $state == 4 ): ?>
<div class="box">
<span class="error"><?=$errmsg?></span>
</div>
<form name="confirmform" method="POST">
<input type="hidden" name="replace" value="">
</form>
<script type="text/javascript">
<!--
    var obj = document.confirmform.replace;
    var ans = confirm("File already exists!! Replace?");
    if( ans == true ) {
        obj.value = 'true';
        document.confirmform.submit();
    } else {
        obj.value = 'false';
        document.confirmform.submit();
    }
// -->
</script>

<?  else: ?>
<div class="box">
<span class="error"><?=$errmsg?></span>
<div align="center" class="save">
<input type="button" value="<?=get_cm_var('setcfg_ui_add_close')?>" onclick="window.close()">
</div>
</div>

<?  endif; ?>
</body>
</html>

