<?php

/************************************************************
This page accepts the credit card information of users and send to PayPal for billing use.

Called by direct_payment_submit.php

Calls direct_payment_receipt.php (using require_once)

************************************************************/
require_once 'caller_service.php';
require_once '..\\authserv\\fs_lang.php';
require_once '..\\authserv\\common_functions.php';
$receipt_url = "direct_payment_receipt.php";
$has_txn_error=false;
//start handling the post back(for submitting the request to paypay api server)
if(isset($_POST) && 
	(isset($_POST["first_name"]) && isset($_POST["last_name"]) && isset($_POST["credit_card_type"])
	&& isset($_POST["credit_card_number"]) && isset($_POST["exp_date_month"]) 
	&& isset($_POST["exp_date_year"]) && isset($_POST["cvv2_number"]) && isset($_SESSION['pay_info_arr'])
	&& isset($_POST["country_index"]) && isset($_POST["country_code"]) 
	&& isset($_POST["address1"]) && isset($_POST["address2"]) && isset($_POST["city"]) 
	&& isset($_POST["state"]) && isset($_POST["state_index"]) && isset($_POST["zip"]) 	) ){
	
	
	$country_index=$_POST["country_index"];
	$state_index=$_POST["state_index"];
	$pay_info_arr=$_SESSION['pay_info_arr'];
	$payment_type =urlencode( $pay_info_arr['payment_type']);

	$credit_card_type =urlencode( $_POST['credit_card_type']);
	$credit_card_number = urlencode($_POST['credit_card_number']);
	$exp_date_month =urlencode( $_POST['exp_date_month']);
	$exp_date_year=urlencode( $_POST['exp_date_year']);
	$exp_date_long_year =urlencode( "20".$_POST['exp_date_year']);
	$cvv2_number = urlencode($_POST['cvv2_number']);
	$first_name =urlencode( $_POST['first_name']);
	$last_name =urlencode( $_POST['last_name']);
	$amount = urlencode( $pay_info_arr['amount'] );
	$currency_code=urlencode($pay_info_arr['currency_code']);
	$item_name=urlencode($pay_info_arr['item_name']);
	$notify_url =urlencode( $pay_info_arr['notify_url']);
	$custom=urlencode($pay_info_arr['custom']);
	$remote_ip=@$REMOTE_ADDR;
	$country_code = urlencode( $_POST["country_code"] );
	$address1 = urlencode( $_POST["address1"] );
	$address2 = urlencode( $_POST["address2"] );
	$city = urlencode( $_POST["city"] );
	$state = urlencode( $_POST["state"] );
	$zip = urlencode( $_POST["zip"] );
	
	/* Construct the request string that will be sent to PayPal.
	The variable $nvpstr contains all the variables and is a
	name value pair string with & as a delimiter */
	$nvpstr="&PAYMENTACTION=$payment_type&CREDITCARDTYPE=$credit_card_type"
	."&ACCT=$credit_card_number&EXPDATE=".$exp_date_month.$exp_date_long_year
	."&CVV2=$cvv2_number&FIRSTNAME=$first_name&LASTNAME=$last_name&AMT=$amount"
	."&CURRENCYCODE=$currency_code&L_NAME0=$item_name&L_AMT0=$amount"
	."&NOTIFYURL=$notify_url&CUSTOM=$custom&IPADDRESS=$remote_ip"
	."&COUNTRYCODE=$country_code&STREET=$address1&STREET2=$address2&CITY=$city&STATE=$state&ZIP=$zip";
	
	/* Make the API call to PayPal, using API signature.
	   The API response is stored in an associative array called $resArray */
	$resArray=hash_call("doDirectPayment",$nvpstr);

	/* Display the API response back to the browser.
	   If the response from PayPal was a success, display the response parameters'
	   If the response was an error, display the errors received using direct_payment_error.php.
	   */
	$ack = strtoupper($resArray["ACK"]);
	$_SESSION['reshash']=$resArray;
	if($ack=="SUCCESS"){
		//header( 'Location: direct_payment_receipt.php' ) ;
		require_once $receipt_url;
		die;
	}
	else {
		//display error if payment failed
		$error_page = "direct_payment_error.php";
		$has_txn_error=true;//error 
	}
}//end of handling the post back
//handle posts from other pages
else if(!isset($_POST) || !isset($_POST["notify_url"]) || !isset($_POST["amount"]) 
		|| !isset($_POST["item_name"]) || !isset($_POST["custom"]) 
		|| !isset($_POST["currency_code"]) || !isset($_POST["return"]) || !isset($_POST["cancel_return"]) ){
		echo 'Required post fields were not receieved!';
		die;
}else{

	$pay_info_arr['payment_type']="Sale";
	$pay_info_arr['notify_url']=$_POST['notify_url'];
	$pay_info_arr['amount']=number_format($_POST['amount'],2,'.','');
	$pay_info_arr['item_name']=$_POST['item_name'];
	$pay_info_arr['custom']=$_POST['custom'];
	$pay_info_arr['currency_code']=$_POST['currency_code'];
	$pay_info_arr['return']=$_POST['return'];
	$pay_info_arr['cancel_return']=$_POST['cancel_return'];
	
	$_SESSION['pay_info_arr']=$pay_info_arr;
	unset($pay_info_arr);

	//for setting default form value
	//start default form parameters
	$first_name="";
	$last_name="";
	$credit_card_type="";
	$credit_card_number="" ;
	$exp_date_month = "";
	$exp_date_year = "";
	$cvv2_number = "";
	$country_index = "";
	$address1="";
	$address2="";
	$city="";
	$state_index="";
	$state="";
	$zip="";
	//end of default form parameters
	$has_txn_error=false;
}


//start handling the dynamic content for the template

$smarty = new SmartyConnect;
$pay_info_arr=$_SESSION['pay_info_arr'];
$smarty->assign('meta_charset', metaCharset());
$smarty->assign('lang_direct_payment_form_title', get_var('direct_payment_form_title'));
$smarty->assign('lang_direct_payment_review_msg', get_var('direct_payment_review_msg'));
$smarty->assign('lang_direct_payment_plan', get_var('direct_payment_plan'));
$smarty->assign('item_name', $pay_info_arr['item_name']);//
$smarty->assign('lang_direct_payment_plan_total', get_var('direct_payment_plan_total'));
$smarty->assign('currency_code', $pay_info_arr['currency_code']);//
$smarty->assign('amount', $pay_info_arr['amount']);
if ($has_txn_error==true){
	$smarty->assign('info_area_style', '');
} 
else {
	$smarty->assign('info_area_style', 'display:none');
}
if ($has_txn_error==true){
	$smarty->assign('has_txn_error', '1');
}else{
	$smarty->assign('has_txn_error', '0');
}
$smarty->assign('lang_direct_payment_cc_info', get_var('direct_payment_cc_info'));
$smarty->assign('payment_type', $pay_info_arr['payment_type']);//
$smarty->assign('notify_url', $pay_info_arr['notify_url']);//
$smarty->assign('custom', $pay_info_arr['custom']);//
$smarty->assign('return', $pay_info_arr['return']);//
$smarty->assign('cancel_return', $pay_info_arr['cancel_return']);//
$smarty->assign('lang_direct_payment_cc_first_name', get_var('direct_payment_cc_first_name'));
$smarty->assign('first_name', urldecode($first_name) );
$smarty->assign('lang_direct_payment_cc_last_name', get_var('direct_payment_cc_last_name'));
$smarty->assign('last_name', urldecode($last_name) );
$smarty->assign('lang_direct_payment_cc_type', get_var('direct_payment_cc_type'));
$smarty->assign('lang_direct_payment_cc_select', get_var('direct_payment_cc_select'));
$selected_str='selected="selected"';
if ($credit_card_type=="Visa"){
	$smarty->assign('visa_selected', $selected_str); 
}
if ($credit_card_type=="MasterCard"){
	$smarty->assign('mastercard_selected', $selected_str); 
}
if ($credit_card_type=="Discover"){
	$smarty->assign('discover_selected', $selected_str); 
}
if ($credit_card_type=="Amex"){
	$smarty->assign('amex_selected', $selected_str); 
}
$smarty->assign('lang_direct_payment_cc_visa', get_var('direct_payment_cc_visa'));
$smarty->assign('lang_direct_payment_cc_mastercard', get_var('direct_payment_cc_mastercard'));
$smarty->assign('lang_direct_payment_cc_discover', get_var('direct_payment_cc_discover'));
$smarty->assign('lang_direct_payment_cc_amex', get_var('direct_payment_cc_amex'));
$smarty->assign('lang_direct_payment_cc_num', get_var('direct_payment_cc_num'));
$smarty->assign('lang_direct_payment_cc_num_help', get_var('direct_payment_cc_num_help'));
$smarty->assign('credit_card_number', $credit_card_number);
$smarty->assign('lang_direct_payment_cc_exp_date', get_var('direct_payment_cc_exp_date'));
$smarty->assign('lang_direct_payment_cc_exp_month', get_var('direct_payment_cc_exp_month'));
$smarty->assign('lang_direct_payment_cc_exp_year', get_var('direct_payment_cc_exp_year'));
$smarty->assign('exp_date_month', $exp_date_month);
$smarty->assign('exp_date_year', $exp_date_year);
$smarty->assign('lang_direct_payment_cc_cvv2', get_var('direct_payment_cc_cvv2'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_title', get_var('direct_payment_cc_cvv2_help_title'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_hide', get_var('direct_payment_cc_cvv2_help_hide'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_3', get_var('direct_payment_cc_cvv2_help_3'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_4', get_var('direct_payment_cc_cvv2_help_4'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_change_3', get_var('direct_payment_cc_cvv2_help_change_3'));
$smarty->assign('lang_direct_payment_cc_cvv2_help_change_4', get_var('direct_payment_cc_cvv2_help_change_4'));
$smarty->assign('lang_direct_payment_cc_cvv2_3', get_var('direct_payment_cc_cvv2_3'));
$smarty->assign('lang_direct_payment_cc_cvv2_4', get_var('direct_payment_cc_cvv2_4'));
$smarty->assign('cvv2_number', $cvv2_number);
$smarty->assign('lang_direct_payment_cc_adr_title', get_var('direct_payment_cc_adr_title'));
$smarty->assign('lang_direct_payment_cc_country', get_var('direct_payment_cc_country'));
$smarty->assign('direct_payment_cc_country_idx', $country_index );
$smarty->assign('lang_direct_payment_cc_country_select', get_var('direct_payment_cc_country_select'));
$smarty->assign('lang_direct_payment_cc_adr_1', get_var('direct_payment_cc_adr_1'));
$smarty->assign('direct_payment_cc_adr_1', urldecode($address1) );
$smarty->assign('lang_direct_payment_cc_adr_2', get_var('direct_payment_cc_adr_2'));
$smarty->assign('direct_payment_cc_adr_2', urldecode($address2) );
$smarty->assign('lang_direct_payment_cc_optional', get_var('direct_payment_cc_optional'));
$smarty->assign('lang_direct_payment_cc_city', get_var('direct_payment_cc_city'));
$smarty->assign('direct_payment_cc_city', urldecode($city) );
$smarty->assign('lang_direct_payment_cc_state', get_var('direct_payment_cc_state'));
$smarty->assign('lang_direct_payment_cc_province', get_var('direct_payment_cc_province'));
$smarty->assign('lang_direct_payment_cc_state_province', get_var('direct_payment_cc_state_province'));
$smarty->assign('lang_direct_payment_cc_state_select', get_var('direct_payment_cc_state_select'));
$smarty->assign('lang_direct_payment_cc_province_select', get_var('direct_payment_cc_province_select'));
$smarty->assign('direct_payment_cc_state_idx', $state_index);
$smarty->assign('direct_payment_cc_state', urldecode($state));
$smarty->assign('lang_direct_payment_cc_zip', get_var('direct_payment_cc_zip'));
$smarty->assign('lang_direct_payment_cc_postal_code', get_var('direct_payment_cc_postal_code'));
$smarty->assign('direct_payment_cc_zip', urldecode($zip));
$smarty->assign('lang_direct_payment_form_continue_btn', get_var('direct_payment_form_continue_btn'));
$smarty->assign('cancel_return', $pay_info_arr['cancel_return']);
$smarty->assign('lang_direct_payment_cancel_btn', get_var('direct_payment_cancel_btn'));
$smarty->display('direct_payment.tpl');
//end of handling the dynamic content for the template
?>