<?php

if (!defined('MAXCHAR'))
	define('MAXCHAR', 25);
if (!defined('MAXFREESITES'))
	define('MAXFREESITES', 100);
if (!defined('MAXLINELEN'))
	define('MAXLINELEN', 512);
if (!defined('MAXDHCP'))
	define('MAXDHCP', 256);
	
if (!class_exists('Site')) {
	class Site
	{
		var $name;
		var $line_no;
		var $checked;
		var $enable_redirect;
		var $redirect_php;
		var $span;

		function Site($name0, $line_no0, $checked0, $checked1,$str)
		{
			$this->name=$name0;
			$this->line_no=$line_no0;
			$this->checked=$checked0;
			$this->enable_redirect=$checked1;
			$this->span=(int)(floor((strlen($this->name)-1)/MAXCHAR))+1;
			$this->redirect_php = $str;
		}
	}
} //end if class_exists


if (!class_exists('Site_Array')) {
	class Site_Array
	{
		var $site_list;
		var $num_sites;
		var $num_lines;

		function Site_Array()
		{
			$this->num_sites=0;
			$this->num_lines=0;
		}

		function add_site($name0, $line_no0, $checked0, $checked1, $str)
		{
			$this->site_list[$this->num_sites]=new Site($name0, $line_no0, $checked0, $checked1, $str);
			$this->num_lines=$this->num_lines + $this->site_list[$this->num_sites]->span;
			$this->num_sites++;
		}

		function check_site($index)
		{
			if ($this->site_list[(int)$index]->checked=='false') {
				$this->site_list[(int)$index]->checked='true';
			} else if ($this->site_list[(int)$index]->checked=='true') {
				$this->site_list[(int)$index]->checked='false';
			} else {
				echo "error in check_site($index)!";
			}
		}

		function purge()
		{
			$i=0;   // edited by Pan, 17_11_2003
			while ($i<$this->num_sites) {
				if ($this->site_list[$i]->checked=='true') {
					if ($this->site_list[$i]->name!='')     //edited by Jason 31-03-04
						$string1=$this->site_list[$i]->name;
					else 
						$string1=$this->site_list[$i]->span;
					if ($string1{0}!='#' && $this->site_list[$i]->name!=''){
						$this->site_list[$i]->name='# '.$string1;
					}
					else if ($string1{0}!='#' && $this->site_list[$i]->span!=''){
						$this->site_list[$i]->span='# '.$string1;
					}
					$this->num_lines=$this->num_lines - $this->site_list[$i]->span;
				}
				$i++;
			}
		}

		function uncheck_all()
		{
			$i = 0;
			while ($i < $this->num_sites) {
				$this->site_list[$i]->checked = 'false';
				$i++;
			}
		}

		function check_all()
		{
			$i = 0;
			while ($i < $this->num_sites) {
				$this->site_list[$i]->checked = 'true';
				$i++;
			}
		}
	}
} // end if class_exists 


if (!class_exists('Saved_Array')) {
	class Saved_Array extends Site_Array
	{
		/*
		**	type: relate to the max 
		** default 'o' = MAXFREESITES, 'd' =  MAXDHCP
		*/
		function Saved_Array($path, $type = 'o')
		{ 
			$this->num_sites=0;
			$this->num_lines=0;

			$file_to_read = fopen($path, 'r') 
			or die ('Cannot open or create configuration file for exception free sites');
			$j=0;
			
			if ($type=='d'){
				$max = MAXDHCP;
			}else
				$max = MAXFREESITES;
			
			// 20081020 - Remove unnecessary condition check
			while ((!feof($file_to_read)) && ($this->num_sites<$max)) {
				$line = trim(fgets($file_to_read, MAXLINELEN));
				if (($line!='') && (strpos($line,';')!==0)) {
					$this->add_site($line,$j,'false',FALSE,'');
				}  
				$j++;
			}
			fclose($file_to_read);

			// Sort & remove duplicates for display
			if ($this->num_sites>0) { 
				$this->sort_list(&$this->site_list);

				$j=0; $k=1;
				while ($k<$this->num_sites) {
					if ($this->site_list[$j]->name==$this->site_list[$k]->name) {
						$this->site_list[$k]->name=';';
						$this->site_list[$k]->checked='duplicates'; // mark for deletion
						$k++;
					} else { 
						$j=$k; $k++;
					}
				} // end while
			} // end if
		} // end function

		// Sort function for the array of sites, implementation being insertion sort here
		function sort_list() 
		{ 
			$i=1;
			while ($i<$this->num_sites) {
				$name0=$this->site_list[$i]->name;
				$line_no0=$this->site_list[$i]->line_no;
				$checked0=$this->site_list[$i]->checked;
				$checked1=$this->site_list[$i]->enable_redirect;
				$span0=$this->site_list[$i]->span;
				$redirect=$this->site_list[$i]->redirect_php;

				$j=$i;
				while (($j>0)&&(strcasecmp($this->site_list[$j-1]->name,$name0)>0)) {
					$this->site_list[$j]->name=$this->site_list[$j-1]->name;
					$this->site_list[$j]->line_no=$this->site_list[$j-1]->line_no;
					$this->site_list[$j]->checked=$this->site_list[$j-1]->checked;
					$this->site_list[$j]->enable_redirect=$this->site_list[$j-1]->enable_redirect;
					$this->site_list[$j]->span=$this->site_list[$j-1]->span;
					$this->site_list[$j]->redirect_php=$this->site_list[$j-1]->redirect_php;
					$j--;
				}
				$this->site_list[$j]->name=$name0;
				$this->site_list[$j]->line_no=$line_no0;
				$this->site_list[$j]->checked=$checked0;
				$this->site_list[$j]->enable_redirect=$checked1;
				$this->site_list[$j]->span=$span0;
				$this->site_list[$j]->redirect_php=$redirect;

				$i++;
			}
		} // end sort_list
	}
} // end if class_exists

?>
