<?php
/**
 *  Allow admins to edit the content of default language file
 *  Notes:
 *      All the changes will be saved in $lang_pack_file, not in the actual default file
 */

// check access right
require_once "secureLogin.php";

require_once "form_elements.php";

// get input value
function get_input_var($element)
{
    global $lang;

	// 20090615 - Decode characters
	return (isset($lang[$element])? html_entity_decode($lang[$element], ENT_NOQUOTES) : '');
}
function get_ln($element)
{
    return '<input class="longtextbox" type="text" name="'.$element.'" value="'.get_input_var($element).'"  onfocus="this.select()">';
}
// for extra information fields only
function get_ln_extra($element, $checkbox)
{
    return '<input class="longtextbox" type="text" name="'.$element.'" value="'.get_input_var($element)."\" onKeyUp=\"checkRequire(this, '$checkbox');\" onfocus=\"this.select()\">";
}
function get_checkbox_extra($element, $checkbox)
{
    if(($GLOBALS["settingobj"]->getKey($checkbox , "lang"))=="on")
        return '<input type="checkbox" name="'.$checkbox.'" checked="checked" value="on">';
    else {
        if(get_input_var($element) == '')
            return '<input type="checkbox" name="'.$checkbox.'" disabled value="on">';
        else
            return '<input type="checkbox" name="'.$checkbox.'" value="on">';
    }
}

// 20080430
function get_input_text($element, $sFilePath)
{
    $bTagFound = false;
    $sRet = '';
    $sTag = '['.$element.']';

    if (isset($sFilePath) && $sFilePath != '') {
	$fp = fopen($sFilePath, 'rt');
	if ($fp) {
	    while (!feof($fp)) {
		$buffer = fgets($fp);
		if ($buffer[0] == ';') {
		    continue;
		}
		if (!$bTagFound && strncmp($buffer, $sTag, strlen($sTag)) == 0) {
		    $bTagFound = true;
		    continue;
		}
		if ($bTagFound && strlen($buffer) >= 2 && $buffer[0] == '[' && ($buffer[strlen($buffer)-2] == ']' || $buffer[strlen($buffer)-1] == ']')) {
		    break;
		}
		if ($bTagFound) {
		    $sRet .= "$buffer";
		}
	    }
	    fclose($fp);
	}
    }
	
	if ($bTagFound==true)
		return $sRet;
	else
		return '';
}

// 20080430
function get_textarea($element)
{
    $cfgObj = new COM('FSCONFIG.Cfgmgr') or die('editlang.php FSCONFIG.Cfgmgr Object cannot be created!');
	$sDefaultFilePath = $cfgObj->getKey('default_login_text_path', 'lang');
    $sCustomFilePath = $cfgObj->getKey('login_text_path', 'lang');
    $cfgObj = null;

	$textAreaContent='';
	$textAreaCustomContent=get_input_text($element, $sCustomFilePath);
	if ($textAreaCustomContent !='')
		$textAreaContent = $textAreaCustomContent;
	else{
		$textAreaDefaultContent=get_input_text($element, $sDefaultFilePath);
		$textAreaContent = $textAreaDefaultContent;	
	}
	
    return '<textarea class="standard" name="'.$element.'" onfocus="this.select()">'.$textAreaContent.'</textarea>';
}

// create COM object
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("setcfg.php FSCONFIG.Cfgmgr Object cannot be created!");

$langdir = "..\\authserv\\lang\\";
$usersettingdir = "..\\usersetting\\";
$default_lang_file = $settingobj->getKey( "default_lang_file", "lang");
$lang_pack_file = $settingobj->getKey( "lang_pack_file", "lang");

// 20090918 - Get control display options
$disable_show_reminder = $settingobj->getKey("disable_show_reminder", "lang");
$disable_show_example = $settingobj->getKey("disable_show_example", "lang");
$disable_show_link = $settingobj->getKey("disable_show_link", "lang");
$disable_show_tc = $settingobj->getKey("disable_show_tc", "lang");

if (!is_file($langdir.$default_lang_file)) {
    gen_sep();
    gen_line('<span class="captionbig" style="color:red;">Language file not found</span>', '');
    gen_sep();
} else {
	ob_start();
    // include default language file
    require_once $langdir.$default_lang_file;
    // include lang pack file
    include_once $usersettingdir.$lang_pack_file;
	ob_end_clean();

    echo '
        <script type="text/javascript" src="./javascript/lang.js"></script>
        <input type="hidden" name="editfile" value="">'."\n";

    //**************************************************************************************
    //  login.php
    //**************************************************************************************
    // 20090305 - Add label for shared secret input
    // 20080429 - Add terms text
    // 20080424 - Delete cookies row, add term row
    // 20080418 - Add scratch code row
    $var = array(
        'greeting',
        'language',
        'user_name',
        'Password',
	'user_scratch',
        'submit_btn',
        'sign_up_now',
        'anonymous',
	'anonymous_shared_secret',
        'ok_btn',
        'invalid',
        'logged',
        'no_usage',
        'browse_freely',
        'not_support_frames',
        'invalid_access',
    	'reach_conc_limit',
		'login_max_conc',
		'logged_in_other_fs',
		'fail_force_logout_from_other_fs_button',
	'SECTION_REMIND',
	'example',
	'free_website',
	'SECTION_LINK',
	'term_condition',
	'SECTION_TERM'
    );
    $cmvar = array(
        'setcfg_ui_login_greeting_msg',
        'setcfg_ui_login_language_field_label',
        'setcfg_ui_login_username_field_label',
        'setcfg_ui_login_password_field_label',
        'setcfg_ui_login_scratch_field_label',
        'setcfg_ui_login_button_label_for_username_password',
        'setcfg_ui_login_caption_for_signup',
        'setcfg_ui_login_add_msg_for_anonymous_mode',
	'setcfg_ui_login_shared_secret_field_label',
        'setcfg_ui_login_btn_label_in_anonymous_mode',
        'setcfg_ui_login_err_msg_for_invalid_username_password',
        'setcfg_ui_login_err_msg_for_duplicate_logins',
        'setcfg_ui_login_err_msg_for_no_timeleft',
        'setcfg_ui_login_win_title_for_exception_free_website',
        'setcfg_ui_login_err_msg_for_browsers_not_support_frames',
	'setcfg_ui_login_err_msg_for_rarely_seen_errors',
	'setcfg_ui_login_warn_msg_for_reach_conc_limit',
	'setcfg_ui_login_err_msg_for_reach_conc_limit',
	'setcfg_ui_login_err_msg_for_logged_in_from_other',
	'setcfg_ui_login_btn_label_for_logged_in_from_other',
	'setcfg_ui_login_remind_text',
	'setcfg_ui_login_caption_label_for_local_content_eg',
	'setcfg_ui_login_caption_label_for_free_website',
	'setcfg_ui_login_link_text',
	'setcfg_ui_login_caption_label_for_term',
	'setcfg_ui_login_term_text'
    );
    $div = 'divUILoginPage';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_login_heading'), $div, count($var));
    gen_sep();

	// 20090918 - Add checkbox control for related field display in login page
    // 20080430 - Add case for showing text area
    foreach ($var as $key => $value) {
		if ($value == 'free_website' || $value == 'term_condition') {
			gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
		} elseif ($value == 'SECTION_REMIND' || $value == 'example' || $value == 'SECTION_LINK' || $value == 'SECTION_TERM') {
			$checkboxId = '';
			$fCheck = '';
			if ($value == 'SECTION_REMIND') {
				$checkboxId = 'disable_show_reminder';
				if (isset($disable_show_reminder) && $disable_show_reminder == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", true);
			} elseif ($value == 'example') {
				$checkboxId = 'disable_show_example';
				if (isset($disable_show_example) && $disable_show_example == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
			} elseif ($value == 'SECTION_LINK') {
				$checkboxId = 'disable_show_link';
				if (isset($disable_show_link) && $disable_show_link == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", false);
			} elseif ($value == 'SECTION_TERM') {
				$checkboxId = 'disable_show_tc';
				if (isset($disable_show_tc) && $disable_show_tc == 1) {
					$fCheck = 'checked';
				}
				gen_invisible_textarea(get_cm_var($cmvar[$key]), get_textarea($value), $div.$key, "none", false);
			}
			gen_invisible_checkbox($div.$key, 'none', $checkboxId, $fCheck);
			gen_invisible_sep($div."Sep".$key, "none");
		} else {
			gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
			gen_invisible_sep($div."Sep".$key, "none");
		}
	}

    //**************************************************************************************
    //  InfoBox
    //**************************************************************************************
    $var = array(
        'info_thank_you',
        'info_cart_btn',
        'info_logout_btn',
        'info_chgpwd_btn',
        'alert',
        'info_title',
        'info_access_min_remain',
		'anon_info_access_min_remain',
        'Unlimited',
        'Min',
        'last_than_one_min',
        'info_please_login_again',
        'info_if_close',
        'info_logout',
        'info_in_browser',
		'info_first_loading_msg',
		'info_loading',
		'info_logged_in_from_other',
        //disconnect.php (under the InfoBox heading in UI)
        'Disconnected',
        'signed_success',
        //remaining of info.php - rarely seen - put aside to minimize confusion to users
        'info_expired',
        'info_please_logout'
    );
    $cmvar = array(
        'setcfg_ui_infobox_greeting_msg',
        'setcfg_ui_infobox_btn_label_for_get_air_time',
        'setcfg_ui_infobox_btn_label_for_logout',
        'setcfg_ui_infobox_btn_label_for_chgpwd',
        'setcfg_ui_infobox_msg_confirm_closing',
        'setcfg_ui_infobox_win_title',
        'setcfg_ui_infobox_caption_access_min_remaining',
		'setcfg_ui_infobox_anon_access_min_remaining',
        'setcfg_ui_infobox_describe_unlimited_access_timeleft',
        'setcfg_ui_infobox_describe_minute',
        'setcfg_ui_infobox_describe_less_than_one_minute',
        'setcfg_ui_infobox_msg_connection_idle_timeout',
        'setcfg_ui_infobox_hints_instant_keyword1',
        'setcfg_ui_infobox_hints_instant_keyword2',
        'setcfg_ui_infobox_hints_instant_keyword3',
		'setcfg_ui_infobox_first_load',
		'setcfg_ui_infobox_loading_box_waiting',
		'setcfg_ui_infobox_warn_msg_for_not_support',
        'setcfg_ui_infobox_caption_success_disconnection',
        'setcfg_ui_infobox_msg_success_disconnection',
        'setcfg_ui_infobox_err_msg1',
        'setcfg_ui_infobox_err_msg2'
    );
    $div = 'divUIInfoBox';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_infobox_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
	gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  logout.php, logoutscript.php
    //**************************************************************************************
    $var = array(
        'login_success', 'login_fail', 'back_btn'
    );
    $cmvar = array(
        'setcfg_ui_logout_msg_success_logout', 'setcfg_ui_logout_err_msg_invalid_username_password',
        'setcfg_ui_logout_btn_label_for_anonymous_mode'
    );
    $div = 'divUILogout';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_logout_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  redirect.php
    //**************************************************************************************
    $var = array(
        'redirect_title', 'redirect_wait', 'redirect_msg'
    );
    $cmvar = array(
        'setcfg_ui_redir_win_title', 'setcfg_ui_redir_caption', 'setcfg_ui_redir_message'
    );
    $div = 'divUIRedir';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_redir_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  20081219 - Block page
    //**************************************************************************************
    $var = array(
	'block_ip_block_list',
	'block_client_blacklist'
    );
    $cmvar = array(
	'setcfg_ui_block_ip_block_list',
	'setcfg_ui_block_client_blacklist'
    );
    $div = 'divUIBlock';

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_block_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, 'none');
        gen_invisible_sep($div."Sep".$key, 'none');
    }

    //**************************************************************************************
    //  chgpwd_form.php
    //**************************************************************************************
    $var = array(
        "chgpwd_form",
        "chgpwd_username",
        "chgpwd_oldpwd",
        "chgpwd_pwd1",
        "chgpwd_pwd2",
        "chgpwd_submit_btn",
        //fs_chgpwd.php
        "chgpwd_ok_header",
        "chgpwd_ok_link",
        "chgpwd_fail_header",
        "chgpwd_fail_link",
        "chgpwd_problem_id_empty",
        "chgpwd_problem_old_pwd_empty",
        "chgpwd_problem_new_pwd_empty",
        "chgpwd_problem_pwd_mismatch",
        "chgpwd_problem_id_not_exists",
        "chgpwd_problem_old_pwd_mismatch",
        "chgpwd_problem_access_right"
    );
    $cmvar = array(
        'setcfg_ui_chgpwd_caption',
        'setcfg_ui_chgpwd_label_username',
        'setcfg_ui_chgpwd_label_old_pwd',
        'setcfg_ui_chgpwd_label_new_pwd',
        'setcfg_ui_chgpwd_label_re_new_pwd',
        'setcfg_ui_chgpwd_btn_label_submit',
        'setcfg_ui_chgpwd_caption_success_pwd_chg',
        'setcfg_ui_chgpwd_link_label_success_pwd_chg',
        'setcfg_ui_chgpwd_caption_fail_pwd_chg',
        'setcfg_ui_chgpwd_link_label_fail_pwd_chg',
        'setcfg_ui_chgpwd_err_msg_empty_username',
        'setcfg_ui_chgpwd_err_msg_empty_old_pwd',
        'setcfg_ui_chgpwd_err_msg_empty_new_pwd',
        'setcfg_ui_chgpwd_err_msg_mismatched_pwd',
        'setcfg_ui_chgpwd_err_msg_id_not_exist',
        'setcfg_ui_chgpwd_err_msg_old_pwd_not_match',
        'setcfg_ui_chgpwd_err_msg_no_access_right'
    );
    $div = "divUIChgpwdForm";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_chgpwd_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  cart.php
    //**************************************************************************************
	// 20090428 - Add radius_not_support
    $var = array(
        "cart_welcome",
        "cart_check_timeleft",
        "cart_check_txn",
        "cart_shopping_cart",
        "cart_desc",
        "cart_price",
        "cart_checkout",
        //cookies_warning.php
        "cookies_warning",
        //timeleft.php
        "timeleft_header",
		"cart_form_other_site",
		"cart_radius_not_support"
    );
    $cmvar = array(
        'setcfg_ui_cart_greeting',
        'setcfg_ui_cart_link_label_for_timeleft',
        'setcfg_ui_cart_link_label_for_pre_cc_trans',
        'setcfg_ui_cart_title',
        'setcfg_ui_cart_col1_heading',
        'setcfg_ui_cart_col2_heading',
        'setcfg_ui_cart_btn_label_for_checkout',
        'setcfg_ui_cart_warn_msg_for_not_accept_cookies',
        'setcfg_ui_cart_timeleft_header',
		'setcfg_ui_cart_warn_msg_for_not_support',
		'setcfg_ui_cart_radius_not_support'
    );
    $div = "divUICart";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_cart_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  paypal_history.php
    //**************************************************************************************
	// 20090428 - Add radius_not_support
    $var = array(
        "ppal_history_title",
        "ppal_history_col1",
        "ppal_history_col2",
        "ppal_history_col3",
        "ppal_history_col4",
        "ppal_history_col5",
        "ppal_history_status_empty",
        "ppal_history_status_completed",
        "ppal_history_status_pendingN",
        "ppal_history_status_pendingY",
        "ppal_history_status_refunded",
		"wpay_history_status_cancelled",
		"ppal_history_radius_not_support"
    );
    $cmvar = array(
        'setcfg_ui_cchistory_caption',
        'setcfg_ui_cchistory_col1',
        'setcfg_ui_cchistory_col2',
        'setcfg_ui_cchistory_col3',
        'setcfg_ui_cchistory_col4',
        'setcfg_ui_cchistory_col5',
        'setcfg_ui_cchistory_msg_uncompleted',
        'setcfg_ui_cchistory_msg_completed',
        'setcfg_ui_cchistory_msg_pending_no',
        'setcfg_ui_cchistory_msg_pending_yes',
        'setcfg_ui_cchistory_msg_refunded',
		'setcfg_ui_cchistory_msg_cancelled',
		'setcfg_ui_cchistory_radius_not_support'
    );
    $div = "divUIPaypalHistory";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_cchistory_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  extra information fields
    //**************************************************************************************
    $var = array(
        "extra_field_err_empty"
    );
    $cmvar = array(
        'setcfg_ui_extra_err_msg'
    );
    $div = "divUIExtra";

    $extra = array(
        "extra_field1", "extra_field2", "extra_field3", "extra_field4", "extra_field5",
        "extra_field6", "extra_field7", "extra_field8", "extra_field9", "extra_field10"
    );
    $extracb =  array(
        "extra01", "extra02", "extra03", "extra04", "extra05", "extra06", "extra07", "extra08", "extra09", "extra10"
    );
    $extracmvar =  array(
        'setcfg_ui_extra_field1', 'setcfg_ui_extra_field2', 'setcfg_ui_extra_field3', 'setcfg_ui_extra_field4', 'setcfg_ui_extra_field5',
        'setcfg_ui_extra_field6', 'setcfg_ui_extra_field7', 'setcfg_ui_extra_field8', 'setcfg_ui_extra_field9', 'setcfg_ui_extra_field10'
    );
    $extracbcmvar = array(
        'setcfg_ui_extra_field_req1', 'setcfg_ui_extra_field_req2', 'setcfg_ui_extra_field_req3', 'setcfg_ui_extra_field_req4', 'setcfg_ui_extra_field_req5',
        'setcfg_ui_extra_field_req6', 'setcfg_ui_extra_field_req7', 'setcfg_ui_extra_field_req8', 'setcfg_ui_extra_field_req9', 'setcfg_ui_extra_field_req10'
    );

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_extra_heading'), $div, $n+2*count($extra)+1);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    $value=$settingobj->getKey( "Datasource_extra_field_table", "gateway");
    $input='<input class="longtextbox" type="text" name="Datasource_extra_field_table" value="'.$value.'"  onfocus="this.select()">';
    gen_invisible_line(get_cm_var('setcfg_ui_extra_table'), $input, "divUIExtra21", "none");
    gen_invisible_sep("divUIExtraSep21", "none");

    foreach($extra as $key => $value) {
        gen_invisible_line(get_cm_var($extracmvar[$key]), get_ln_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
        gen_invisible_line(get_cm_var($extracbcmvar[$key]), get_checkbox_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
    }

    
    //**************************************************************************************
    //  Request sign up extra information fields
    //**************************************************************************************
    $var = array(
        //ReqSignUp_form.php
        "ReqSignUp_title",
        "ReqSignUp_header",
        "ReqSignUp_submit_btn",
        //fs_ReqSignUp.php
        "ReqSignUp_ok_header",
        "ReqSignUp_ok_link",
        "ReqSignUp_fail_header",
        "ReqSignUp_fail_link",
        "ReqSignUp_problem_field_empty",
    );
    $cmvar = array(
        'setcfg_ui_RSU_title',
        'setcfg_ui_RSU_caption',
        'setcfg_ui_RSU_btn_label_submit_acc',
        'setcfg_ui_RSU_caption_success',
        'setcfg_ui_RSU_link_label_success',
        'setcfg_ui_RSU_cap_failed',
        'setcfg_ui_RSU_link_label_failed',
        'setcfg_ui_RSU_err_msg_empty_field',
    );
    $div = "divUIRSUForm";

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_RSU_heading'), $div, $n);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    //**************************************************************************************
    //  signup_form.php
    //**************************************************************************************
    // 20080418 - Add scratch mode invalid access label
    $var = array(
        "signup_form",
        "signup_username",
        "signup_pwd1",
        "signup_pwd2",
        "signup_submit_btn",
        //fs_signup.php
        "signup_ok_header",
        "signup_ok_link",
        "signup_fail_header",
        "signup_fail_link",
        "signup_problem_id_empty",
        "signup_problem_pwd_empty",
        "signup_problem_pwd_mismatch",
        "signup_problem_id_duplicate",
        "signup_problem_field_empty",
	"signup_block_msg"
    );
    $cmvar = array(
        'setcfg_ui_signup_caption',
        'setcfg_ui_signup_field_label_username',
        'setcfg_ui_signup_field_label_pwd',
        'setcfg_ui_signup_field_label_re_pwd',
        'setcfg_ui_signup_btn_label_submit_acc',
        'setcfg_ui_signup_caption_success_acc_create',
        'setcfg_ui_signup_link_label_success_acc_create',
        'setcfg_ui_signup_cap_failed_acc_create',
        'setcfg_ui_signup_link_label_failed_acc_create',
        'setcfg_ui_signup_err_msg_empty_username',
        'setcfg_ui_signup_err_msg_empty_pwd',
        'setcfg_ui_signup_err_msg_mismatched_pwd',
        'setcfg_ui_signup_err_msg_duplicated_username',
        'setcfg_ui_signup_err_msg_empty_field',
	'setcfg_ui_signup_block_msg'
    );
    $div = "divUISignupForm";

    // store the number of items array $var
    $n = count($var);

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_signup_heading'), $div, $n);
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }
    
    //**************************************************************************************
    //  extra information fields for self-signup and Administrative create-user
    //**************************************************************************************
    $div = "divUIRSUExtra";

    $extra = array(
        "ReqSignUp_extra1", "ReqSignUp_extra2", "ReqSignUp_extra3", "ReqSignUp_extra4", "ReqSignUp_extra5",
        "ReqSignUp_extra6", "ReqSignUp_extra7", "ReqSignUp_extra8", "ReqSignUp_extra9", "ReqSignUp_extra10"
    );
    $extracb =  array(
        "ReqSignUp01", "ReqSignUp02", "ReqSignUp03", "ReqSignUp04", "ReqSignUp05", "ReqSignUp06", "ReqSignUp07", "ReqSignUp08",
        "ReqSignUp09", "ReqSignUp10"
    );
    $extracmvar =  array(
        'setcfg_ui_RSU_extra1', 'setcfg_ui_RSU_extra2', 'setcfg_ui_RSU_extra3', 'setcfg_ui_RSU_extra4', 'setcfg_ui_RSU_extra5',
        'setcfg_ui_RSU_extra6', 'setcfg_ui_RSU_extra7', 'setcfg_ui_RSU_extra8', 'setcfg_ui_RSU_extra9', 'setcfg_ui_RSU_extra10'
    );
    $extracbcmvar = array(
        'setcfg_ui_RSU_req_extra1', 'setcfg_ui_RSU_req_extra2', 'setcfg_ui_RSU_req_extra3', 'setcfg_ui_RSU_req_extra4', 'setcfg_ui_RSU_req_extra5',
        'setcfg_ui_RSU_req_extra6', 'setcfg_ui_RSU_req_extra7', 'setcfg_ui_RSU_req_extra8', 'setcfg_ui_RSU_req_extra9', 'setcfg_ui_RSU_req_extra10'
    );

    // store the number of items array $var
    $n =0;
    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_RSU_FIELD_heading'), $div, $n+2*count($extra));
    gen_sep();
    
    foreach($extra as $key => $value) {
        gen_invisible_line(get_cm_var($extracmvar[$key]), get_ln_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
        gen_invisible_line(get_cm_var($extracbcmvar[$key]), get_checkbox_extra($value, $extracb[$key]), $div.$n, "none");
        gen_invisible_sep($div."Sep".$n, "none");
        $n++;
    }
    
    

    //**************************************************************************************
    //  print_form.php and print_auth.php
    //**************************************************************************************
    $var = array(
        'print_support',
        'print_ref_id',
        "print_page_count",
        "print_page_left",
        "print_username",
        "print_password",
        "print_error_token",
        "print_error_quota",
        "print_error_pwd"
    );
        $cmvar = array(
        'setcfg_ui_print_link',
        'setcfg_ui_print_refid',
        'setcfg_ui_print_page_count',
        'setcfg_ui_print_page_left',
        'setcfg_ui_print_username',
        'setcfg_ui_print_password',
        'setcfg_ui_print_err_msg_pwd',
        'setcfg_ui_print_err_msg_quota',
        'setcfg_ui_print_err_msg_token'
    );
    $div = "divUIPrintSupport";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_print_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

	//**************************************************************************************
    //  iKeyRedirect_warning.php
    //**************************************************************************************

    $var = array(
        'ikeyRedirect_warn_access_port',
        'ikeyRedirect_warn_access_page'
    );
        $cmvar = array(
        'setcfg_ui_iKey_warn_msg_access_port',
        'setcfg_ui_iKey_warn_msg_access_page'
    );
    $div = "divUIInstantKeyword";

    gen_sep();
    gen_section_heading_button(get_cm_var('setcfg_ui_iKey_heading'), $div, count($var));
    gen_sep();

    foreach($var as $key => $value) {
        gen_invisible_line(get_cm_var($cmvar[$key]), get_ln($value), $div.$key, "none");
        gen_invisible_sep($div."Sep".$key, "none");
    }

    gen_sep();

}
// release the COM object
//$settingobj->Release();
$settingobj=null;

?>
