var isCss, ns, ie, w3;
var intervalId;
var fudgeFactor = {top:-1, left:-1};
var initX, initY;
var notifyName = '';
var newsId;
var gloButtonName = '';

// Detect browser type
function InitDHTMLAPI()
{
	if (document.images) {
		isCss = (document.body && document.body.style)? true : false;
		ns = (document.layers)? true : false;
		ie = (isCss && document.all)? true : false;
		w3 = (isCss && document.getElementById && !ie)? true : false;
	}
}

// Used for getting object
function SeekLayer(doc, objName)
{
	var obj;
	for (i = 0; i < doc.layers.length; i++) {
		if (doc.layers[i].name == objName) {
			obj = doc.layers[i];
			break;
		}
		if (doc.layers[i].document.layers.length > 0) {
			obj = SeekLayer(doc.layers[i].document, objName);
		}
	}
	return obj;
}

// Get raw object
function GetRawObj(objName)
{
	if (ns) {
		return SeekLayer(document, objName);
	} else if (ie) {
		return document.all(objName);
	} else if (w3) {
		return document.getElementById(objName);
	}
}

// Get browser inner width
function GetInWinWidth()
{
	if (window.innerWidth) {
		return window.innerWidth;
	} else if (document.body && document.body.clientWidth) {
		return document.body.clientWidth;
	} else {
		return 0;
	}
}

// Get browser inner height
function GetInWinHeight()
{
	if (window.innerHeight) {
		return (window.innerHeight + document.body.scrollTop);
	} else if (document.body && document.body.clientHeight) {
		return (document.body.clientHeight + document.body.scrollTop);
	} else {
		return 0;
	}
}

// Get object width
function GetObjWidth(obj)
{
	if (obj.offsetWidth) {
		return parseInt(obj.offsetWidth);
	} else if (obj.clip && obj.clip.width) {
		return parseInt(obj.clip.width);
	} else if (obj.style && obj.style.pixelWidth) {
		return parseInt(obj.style.pixelWidth);
	} else {
		return 0;
	}
}

// Get object height
function GetObjHeight(obj)
{
	if (obj.offsetHeight) {
		return parseInt(obj.offsetHeight);
	} else if (obj.clip && obj.clip.height) {
		return parseInt(obj.clip.height);
	} else if (obj.style && obj.style.pixelHeight) {
		return parseInt(obj.style.pixelHeight);
	} else {
		return 0;
	}
}

// Get horizontal position of the object, counting from leftmost of broswer
function GetObjLeft(obj)
{
	if (document.defaultView) {
		return parseInt(document.defaultView.getComputedStyle(obj, "").getPropertyValue("left"));
	} else if (obj.currentStyle) {
		return parseInt(obj.currentStyle.left);
	} else if (obj.style) {
		return parseInt(obj.style.left);
	} else if (ns) {
		return parseInt(obj.left);
	} else {
		return 0;
	}
}

// Get vertical position of the object, counting from top of broswer
function GetObjTop(obj)
{
	if (document.defaultView) {
		return parseInt(document.defaultView.getComputedStyle(obj, "").getPropertyValue("top"));
	} else if (obj.currentStyle) {
		return parseInt(obj.currentStyle.top);
	} else if (obj.style) {
		return parseInt(obj.style.top);
	} else if (ns) {
		return parseInt(obj.top);
	} else {
		return 0;
	}
}

// Set object visible
function ShowObj(obj)
{
	if (obj.style) {
		obj = obj.style;
	}
	obj.visibility = "visible";
}

// Set object invisible
function HideObj(obj)
{
	if (obj.style) {
		obj = obj.style;
	}
	obj.visibility = "hidden";
}

// Reset location of the object
function ShiftFrom(obj, cX, cY)
{
	if (obj.style) {
		obj = obj.style;
	}
	if (ns) {
		obj.moveTo(cX, cY);
	} else {
		obj.left = cX + "px";
		obj.top = cY + "px";
	}
}

// Move object with specified distance
function ShiftBy(obj, dX, dY)
{
	if (obj.style) {
		objStyle = obj.style;
	} else {
		objStyle = obj;
	}
	if (ns) {
		objStyle.moveBy(dX, dY);
	} else {
		objStyle.left = GetObjLeft(obj) + dX + "px";
		objStyle.top = GetObjTop(obj) + dY + "px";
	}
}

// Create moving up action for the object
function ShiftUpAction(layerName, startY, stopY, buttonName)
{
	var obj = GetRawObj(layerName);

	document.body.style.overflow = 'hidden';
	ShiftBy(obj, 0, -1);
	if (GetObjTop(obj) <= stopY) {
		clearInterval(intervalId);
		document.body.style.overflow = '';
		setTimeout("intervalId = setInterval(\"ShiftDownAction('" + layerName + "', '" + buttonName + "')\", 1)", 300000);
	}
}

// Create moving down action for the object
function ShiftDownAction(layerName, buttonName)
{
	var obj = GetRawObj(layerName);

	document.body.style.overflow = 'hidden';
	ShiftBy(obj, 0, 1);
	if (GetObjTop(obj) >= GetInWinHeight()) {
		CloseAction(layerName, buttonName);
		document.body.style.overflow = '';
	}
}

// Initialization for the notify box
function GenNotify(layerName, buttonName)
{
	var obj = GetRawObj(layerName);

	notifyName = layerName;

	if (fudgeFactor.top == -1) {
		if (obj.offsetTop > 0) {
			fudgeFactor.top = obj.offsetTop;
			fudgeFactor.left = obj.offsetLeft;
		} else {
			fudgeFactor.top = 0;
			fudgeFactor.left = 0;
		}
		if (obj.offsetWidth && obj.scrollWidth && obj.offsetWidth != obj.scrollWidth) {
			obj.style.width = obj.scrollWidth;
		}
	}

	initX = GetInWinWidth() - GetObjWidth(obj) - 20 - fudgeFactor.left;
	initY = GetInWinHeight() - fudgeFactor.top;
	var finalX = initX;
	var finalY = GetInWinHeight() - GetObjHeight(obj) - fudgeFactor.top;
	ShiftFrom(obj, initX, initY);
	ShowObj(obj);
	intervalId = setInterval("ShiftUpAction('" + layerName + "', " + initY + ", " + finalY + ", '" + buttonName + "')", 1);
}

// Move multiple objects based on windows action
function AdjustXY()
{
	if (notifyName.length > 0) {
		var obj = GetRawObj(notifyName);
		var newX = GetInWinWidth() - GetObjWidth(obj) - 20 - fudgeFactor.left;
		var newY = GetInWinHeight() - GetObjHeight(obj) - fudgeFactor.top;

		ShiftBy(obj, newX-GetObjLeft(obj), newY-GetObjTop(obj));
	}

	if (gloButtonName.length > 0) {
		var obj = GetRawObj(gloButtonName);
		var newX = GetInWinWidth() - GetObjWidth(obj) - 20;
		var newY = GetInWinHeight() - GetObjHeight(obj);

		ShiftBy(obj, newX-GetObjLeft(obj), newY-GetObjTop(obj));
	}
}

// Clear listener
function UnloadProc()
{
	clearTimeout(newsId);
}

// Close notify box and show news button
function CloseAction(layerName, buttonName)
{
	var buttonObj = GetRawObj(buttonName);
	var layerObj = GetRawObj(layerName);

	HideObj(layerObj);
	ShowObj(buttonObj);
	clearInterval(intervalId);
	ShiftFrom(layerObj, 0, 0);
	notifyName = '';
	document.body.style.overflow = '';
}

// Initialize position for news button
function SetButtonXY(buttonName)
{
	var obj = GetRawObj(buttonName);
	var newX = GetInWinWidth() - GetObjWidth(obj) - 20;
	var newY = GetInWinHeight() - GetObjHeight(obj);

	gloButtonName = buttonName;
	ShiftFrom(obj, newX, newY);
}
