<?php

// 20090430 - Handle URL log retrieving

include ("secureLogin.php");
include_once ("..\\authserv\\common_functions.php");

// create COM object
$settingObj = new COM('FSCONFIG.Cfgmgr') or die ('urllog_entry.php FSCONFIG.Cfgmgr Object cannot be created!');
$isAnony = $settingObj->getKey('anonymous_login', 'gateway');
$settingObj = null;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>URL Log Entry</title>
<style type="text/css">
	table {
		font-family: Arial, sans-serif;
		font-size: 8pt;
	}
</style>
<script type="text/javascript" src="./javascript/loadingBox.js"></script>
<script type="text/javascript" src="./javascript/url_log.js"></script>
</head>
<body>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<?php

$logDirArr = array("..\\log\\archive", "..\\log");
$csvPrfx = 'urldata_';
$csvSufx = '.csv';
$csvArr = array();
$cnt = 0;

// Extract full path of the CSV files
foreach ($logDirArr as $l) {
	$fileArr = scandir($l);
	foreach ($fileArr as $f) {
		$filePath = "$l\\$f";
		if (is_file($filePath) && ereg('^'.$csvPrfx.'[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$csvSufx.'$', $f)) {
			$csvArr[] = $filePath;
		}
	}
}

// Read CSV files one by one
foreach ($csvArr as $c) {
	$fp = fopen($c, 'rt');
	if ($fp != FALSE) {
		$meetTitle = 0;

		// 20090302 - Show port numbers for non-well-known protocols
		// 20090106 - Retrieve destination port and convert to protocol if possible
		while (($dataArr = fgetcsv($fp, 512, ',', "'")) !== FALSE) {
			// Skip the title line
			if ($meetTitle == 0) {
				$meetTitle = 1;
				continue;
			}

			if (count($dataArr) == 8) {
				$name = $dataArr[0];
				$logintime = $dataArr[1];
				$MacAddr = $dataArr[2];
				$IPAddr = $dataArr[3];
				$url = $dataArr[4];
				$loginTimeInt = $dataArr[5];
				$DestipAddr = $dataArr[6];
				$destPort = (int)$dataArr[7];

				$tok = strtok($MacAddr, ':');
				$i = 0;
				$mac[$i++] = $tok;

				while ($tok) {
					$tok = strtok(':');
					$mac[$i++] = $tok;
				}

				$MacAddr = $mac[0].'-'.$mac[1].'-'.$mac[2].'-'.$mac[3].'-'.$mac[4].'-'.$mac[5];

				switch ($destPort) {
				case 20:
				case 21:
					$protocol = 'FTP';
					break;
				case 23:
					$protocol = 'Telnet';
					break;
				case 25:
					$protocol = 'SMTP';
					break;
				case 53:
					$protocol = 'DNS';
					break;
				case 67:
				case 68:
					$protocol = 'DHCP';
					break;
				case 80:
					$protocol = 'HTTP';
					break;
				case 110:
					$protocol = 'POP3';
					break;
				case 443:
					$protocol = 'SSL';
					break;
				case 995:
					$protocol = 'POP3S';
					break;
				default:
					$protocol = $destPort;
				}

?>
	<tr onMouseOut="HighlightRow(this, 0)" onMouseOver="HighlightRow(this, 1)">
<?php

				if (!strtolower($isAnony == 'on')) {

?>
					<td width="18%"><?=$name?></td>
<?php

				}

?>
		<td width="18%"><?=$logintime?></td>
		<td width="12%"><?=$MacAddr?></td>
		<td width="10%"><?=$IPAddr?></td>
		<td width="8%"><?=$protocol?></td>
		<td width="12%"><?=$DestipAddr?></td>
		<td width="22%"><?=$url?></td>
		<script>
			SetExtraInfo(<?=$cnt++?>, 'loginTimeInt', "<?=$loginTimeInt?>");
		</script>
	</tr>
<?php

			}
		}

		fclose($fp);
	}
}

?>
</table>
<script type="text/javascript">
	CallParentLoadingBox(false, false);
</script>
</body>
</html>
